#ifndef EFL_UI_DRAGGABLE_EO_HH
#define EFL_UI_DRAGGABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_draggable.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace ui { 
struct Draggable;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Draggable> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace ui { 
struct Draggable {
   ::efl::eolian::return_traits<bool>::type drag_target_get() const;
   ::efl::eolian::return_traits<void>::type drag_target_set( ::efl::eolian::in_traits<bool>::type set) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_UI_DRAGGABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::Draggable() const;
   operator ::efl::ui::Draggable&();
   operator ::efl::ui::Draggable const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Draggable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Draggable const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Draggable : ::efl::eo::concrete
{
   explicit Draggable( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Draggable(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Draggable(Draggable const& other) = default;
   Draggable(Draggable&& other) = default;
   Draggable& operator=(Draggable const& other) = default;
   Draggable& operator=(Draggable&& other) = default;
   Draggable()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Draggable( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Draggable(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type drag_target_get() const;
   ::efl::eolian::return_traits<void>::type drag_target_set( ::efl::eolian::in_traits<bool>::type set) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_UI_DRAGGABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct drag_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG; }
      typedef void parameter_type;
   } const drag_event;
   static struct drag_start_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_START; }
      typedef void parameter_type;
   } const drag_start_event;
   static struct drag_stop_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_STOP; }
      typedef void parameter_type;
   } const drag_stop_event;
   static struct drag_end_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_END; }
      typedef void parameter_type;
   } const drag_end_event;
   static struct drag_start_up_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_START_UP; }
      typedef void parameter_type;
   } const drag_start_up_event;
   static struct drag_start_down_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_START_DOWN; }
      typedef void parameter_type;
   } const drag_start_down_event;
   static struct drag_start_right_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_START_RIGHT; }
      typedef void parameter_type;
   } const drag_start_right_event;
   static struct drag_start_left_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_START_LEFT; }
      typedef void parameter_type;
   } const drag_start_left_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Draggable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Draggable const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Draggable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Draggable>::value, "");
} } 
#include "efl_ui_draggable.eo.impl.hh"
#endif
